var utils = require("./_utils.js");

/**
 * Apply value to object
 * 
 * @param {object} object target object
 * @param {string} path path to property
 * @param {function} value value factory fo property
 */
function applyPath(object, path, value) {
    if (!object) throw "target is null";

    var root = object;
    for (var i = 0; i < path.length; i++) {
        var prop = path[i];
        var assumeRootIsArray = Number.isInteger(prop);
        var assumePropertyIsArray = Number.isInteger(path[i + 1]);
        var current = root[prop];

        if (assumeRootIsArray && !utils.isArray(root)) {
            throw "wrong path to array";
        }

        if (!assumeRootIsArray && utils.isArray(root)) {
            throw "wrong path to object";
        }

        if (current && assumePropertyIsArray && !utils.isArray(current)) {
            throw "wrong path to array";
        }

        if (current && !assumePropertyIsArray && utils.isArray(current)) {
            throw "wrong path to object";
        }

        if (!current) {
            // create if does not exists
            current = assumePropertyIsArray ? [] : {};
        }

        // apply value prop;
        if (i == path.length - 1) {
            current = value;
        }

        root[prop] = current;
        root = current;
    }
}
module.exports = applyPath;